您的位置:首页 > 大数据 > 人工智能

【Codeforces Round 336 (Div 2) A】【贪心 水题】Saitama Destroys Hotel 电梯只下不上 接n人到达0层最早时刻

2015-12-25 11:44 483 查看
A. Saitama Destroys Hotel

time limit per test
1 second

memory limit per test
256 megabytes

input
standard input

output
standard output

Saitama accidentally destroyed a hotel again. To repay the hotel company, Genos has volunteered to operate an elevator in one of its other hotels. The elevator is special — it starts
on the top floor, can only move down, and has infinite capacity. Floors are numbered from 0 to s and
elevator initially starts on floor s at time 0.
The elevator takes exactly 1 second
to move down exactly 1 floor and negligible time to pick up passengers. Genos is given a list detailing when and
on which floor passengers arrive. Please determine how long in seconds it will take Genos to bring all passengers to floor 0.

Input
The first line of input contains two integers n and s (1 ≤ n ≤ 100, 1 ≤ s ≤ 1000) —
the number of passengers and the number of the top floor respectively.
The next n lines
each contain two space-separated integers fi and ti (1 ≤ fi ≤ s, 1 ≤ ti ≤ 1000) —
the floor and the time of arrival in seconds for the passenger number i.

Output
Print a single integer — the minimum amount of time in seconds needed to bring all the passengers to floor 0.

Sample test(s)

input
3 7
2 1
3 8
5 2


output
11


input
5 10
2 77
3 33
8 21
9 12
10 64


output
79


Note
In the first sample, it takes at least 11 seconds
to bring all passengers to floor 0. Here is how this could be done:
1. Move to floor 5: takes 2 seconds.
2. Pick up passenger 3.
3. Move to floor 3: takes 2 seconds.
4. Wait for passenger 2 to arrive:
takes 4 seconds.
5. Pick up passenger 2.
6. Go to floor 2: takes 1 second.
7. Pick up passenger 1.
8. Go to floor 0: takes 2 seconds.
This gives a total of 2 + 2 + 4 + 1 + 2 = 11 seconds.

#include<stdio.h>
#include<iostream>
#include<string.h>
#include<string>
#include<ctype.h>
#include<math.h>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<bitset>
#include<algorithm>
#include<time.h>
using namespace std;
void fre(){freopen("c://test//input.in","r",stdin);freopen("c://test//output.out","w",stdout);}
#define MS(x,y) memset(x,y,sizeof(x))
#define MC(x,y) memcpy(x,y,sizeof(x))
#define MP(x,y) make_pair(x,y)
#define ls o<<1
#define rs o<<1|1
typedef long long LL;
typedef unsigned long long UL;
typedef unsigned int UI;
template <class T1,class T2>inline void gmax(T1 &a,T2 b){if(b>a)a=b;}
template <class T1,class T2>inline void gmin(T1 &a,T2 b){if(b<a)a=b;}
const int N=0,M=0,Z=1e9+7,ms63=0x3f3f3f3f;
int casenum,casei;
int n,s;
int f,t;
int main()
{
while(~scanf("%d%d",&n,&s))
{
int ans=s;
for(int i=1;i<=n;++i)
{
scanf("%d%d",&f,&t);
gmax(ans,f+t);
}
printf("%d\n",ans);
}
return 0;
}
/*
【题意】
我们有一个电梯,电梯只能从上往下开。
电梯在时刻0时在第s(1<=s<=1000)层,有n(100)个人上电梯。
告诉你每个人上电梯的楼层f和时刻t,让你输出我们最早到达0层的时刻。

【类型】
贪心

【分析】
显然,我们到达0层的时刻,至少为s。
然后,因为我们需要接人,于是对于每个人,都需要gmax(ans,f+t)
表示,接这个人至少要t秒,送这个人到0层至少要f秒,于是总时间就是max(f+t)。

不要忘记,必要时间至少为s哦~

*/
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息